;;
;; lisp assignment 
;;
(format t "~%")
(format t "~a~% ~a~% ~a~% ~s~% ~a~% ~s~% ~a~% ~s~% ~a~% ~S~% ~a~% ~a~%~%"
"You are to write a LISP function named COUNT-NILS which will scan a list and "
"count the NIL atoms at the top level."
"Here are two examples of its use:"
"  (count-nils '(a b))  "
"will produce "
"  0"
"and"
"  (count-nils '(a NIL 5 (b c) NIL (NIL NIL))) "
"will produce:"
"  2"
"In the second example the list (NIL NIL) contains two NILs but they are"
" not at the top level."
)
;;
(format t "Setting test1 to ~s~%" '(a b))
(setq test1 '(a b))
(format t "Setting test2 to ~s~%" '(a NIL 5 (b c) NIL (NIL NIL)))
(setq test2 '(a NIL 5 (b c) NIL (NIL NIL)))
;;
(defun count-nils (lst)
  (cond
    ((null lst) 0)
    ((null (car lst)) (+ 1 (count-nils (cdr lst))))
    (t (count-nils (cdr lst)))))
;;
(format t "calling count-nils on test1: ")
;;
(setq rslt (count-nils test1))
(format t "result is ~d~%" rslt)
;;
(format t "calling count-nils on test2: ")
;;
(setq rslt (count-nils test2))
(format t "result is ~d~%" rslt)
;;
(format t "~%~%")
;;
